<?php
namespace Teknisa\ACL\Repositories;

use Doctrine\DBAL\Connection;

class OperadorPrincipalRepository {
    
    protected $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    public function getMaxOperCode($params) {
        
        $select = "SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(DECODE(REPLACE(TRANSLATE(CDOPERADOR, '0123456789', '##########'), '#', ''), NULL, CDOPERADOR, NULL)))+1), 12, '0') MAX_ID 
                    FROM OPERADOR WHERE NRORG =:NRORG";
        try {
            
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
            return $result[0]["MAX_ID"]+1;
        
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function criaParcnegocio($params) {
    
        $insert = "INSERT INTO PARCNEGOCIO
                              (NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC, IDATIVO,
                               DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, CDTIPOPARCPRINCIPAL, CDTIPOINSCRICAO,
                               IDPESSOAFISICA, IDINSTITUICAO, IDPARCFUNDIDO)
                       VALUES (:NRPARCNEGOCIO, :NRORG, :NMOPERADOR, :NMOPERADOR, :NRINSCRICAOPARC, :IDATIVO,
                                SYSDATE, :NRORG, :CDOPERINCLUSAO, :CDTIPOPARCPRINCIPAL, :CDTIPOINSCRICAO,
                               :IDPESSOAFISICA, :IDINSTITUICAO, :IDPARCFUNDIDO)";
        try {
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
    
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
        
        };
    }
    
    public function criaParceria($params) {
        
        $insert = "INSERT INTO PARCERIA
                              (NRPARCERIA, NRPARCNEGOCIO, CDTIPOPARCEIRO, NRORG, IDATIVO,
                               DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                       VALUES (:NRPARCERIA, :NRPARCNEGOCIO, :CDTIPOPARCEIRO, :NRORG, :IDATIVO,
                                SYSDATE, :NRORG, :CDOPERINCLUSAO)";
        try {
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function criaRelacionaParc($params) {
        $insert = "INSERT INTO RELACIONAPARC
                              (NRRELACIONAPARC, NRORG, NRPARCNEGOCIO, NRPARCNEGRELAC, NRTIPORELACIONA,
                               IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                        SELECT :NRRELACIONAPARC AS NRRELACIONAPARC, :NRORG AS NRORG, NRPARCNEGOCIO,
                               :NRPARCNEGOCIO AS NRPARCNEGRELAC, :NRTIPORELACIONA AS NRTIPORELACIONA,
                               :IDATIVO AS IDATIVO, SYSDATE AS DTINCLUSAO, :NRORG AS NRORGINCLUSAO,
                               :CDOPERINCLUSAO AS CDOPERINCLUSAO
                          FROM CLIENTE
                         WHERE CDCLIENTE = :CDCLIENTE
                           AND NRORG     = :NRORG";
        try {
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
     public function criaInteclie($params) {
        $insert = "INSERT INTO INTECLIE
                              (CDCLIENTE, CDINTECLIE, NMINTECLIE, CDPAIS, NRORG, DTINCLUSAO,
                               NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO, NRRELACIONAPARC)
                       VALUES (:CDCLIENTE, :CDINTECLIE, :NMOPERADOR, :CDPAIS, :NRORG, SYSDATE,
                               :NRORG, :CDOPERINCLUSAO, :IDATIVO, :NRRELACIONAPARC)";
        try {
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function criaOrganOper($params) {
        $insert = "INSERT INTO ORGANIZACAOOPER
                              (NRORGANIZACAOOPER, NRORGREL, CDOPERADOR, DTINCLUSAO, NRORGINCLUSAO,
                               CDOPERINCLUSAO, NRORG, IDATIVO)
                       VALUES (:NRORGANIZACAOOPER, :NRORGTRAB, :CDOPERADOR, SYSDATE, :NRORG,
                               :CDOPERINCLUSAO, :NRORG, :IDATIVO)";
        try {
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function saveFilial($params){
        $insert = "INSERT INTO FILIOPER
                              (CDOPERADOR, CDFILIAL, IDEXIBAVISO, DTULTATUFOPE, NRORG, DTINCLUSAO,
                               DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, NRORGFILIAL, IDATIVO)
                       VALUES (:CDOPERADOR, :CDFILIAL, :IDEXIBAVISO, SYSDATE, :NRORG, SYSDATE,
                               SYSDATE, :NRORG, :CDOPERINCLUSAO, :NRORG, :CDOPERINCLUSAO, :NRORG, :IDATIVO)";
        try {
            
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };   
    }
    
    public function getOrganizacao($params){
        $select = "SELECT NMORGANIZACAO
                     FROM ORGANIZACAO
                    WHERE NRORG = :NRORG";
        try {
            
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
            return array("NMORGANIZACAO" => $result[0]["NMORGANIZACAO"]);
        
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };   
    }
    
    public function updateParcnegocio($params){
        $update = "UPDATE PARCNEGOCIO
                      SET NRINSCRICAOPARC = :NRINSCRICAOPARC,
                          CDTIPOINSCRICAO = :CDTIPOINSCRICAO,
                          NMPRINCIPALPARC = :NMOPERADOR,
                          NMSECUNDARIPARC = :NMOPERADOR,
                          DTULTATU        = SYSDATE,
                          NRORGULTATU     = :NRORGULTATU,
                          CDOPERULTATU    = :CDOPERULTATU
                    WHERE NRPARCNEGOCIO   = :NRPARCNEGOCIO
                      AND NRORG           = :NRORG";
        try
        {
            $std = $this->connection->prepare($update);
            $std->execute($params);
        }catch(\Exception $e)
        {
            throw new \Exception($e->getMessage());
        };
    }
    
    public function inativaTodosRelacParc($params) {
        $update = "UPDATE RELACIONAPARC
                      SET IDATIVO         = :IDATIVO,
                          CDOPERULTATU    = :CDOPERULTATU,
                          NRORGULTATU     = :NRORGULTATU,
                          DTULTATU        = SYSDATE
                    WHERE NRPARCNEGRELAC  = :NRPARCNEGOCIO
                      AND NRORG           = :NRORG
                      AND NRTIPORELACIONA = :NRTIPORELACIONA";
        try {
            
            $std = $this->connection->prepare($update);
            $std->execute($params);
        
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function inativaTodosInteClie($params) {
        $update = "UPDATE INTECLIE
                      SET IDATIVO         = :IDATIVO,
                          CDOPERULTATU    = :CDOPERULTATU,
                          NRORGULTATU     = :NRORGULTATU,
                          DTULTATU        = SYSDATE
                    WHERE NRRELACIONAPARC IN
                          (SELECT NRRELACIONAPARC
                             FROM RELACIONAPARC
                            WHERE NRPARCNEGRELAC  = :NRPARCNEGOCIO
                              AND NRORG           = :NRORG
                              AND NRTIPORELACIONA = :NRTIPORELACIONA)
                      AND NRORG           = :NRORG";

        try {
            
            $std = $this->connection->prepare($update);
            $std->execute($params);
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function setParceriaAtivaInativa($params) {
        $update = "UPDATE PARCERIA
                      SET IDATIVO        = :IDATIVO,
                          CDOPERULTATU   = :CDOPERULTATU,
                          NRORGULTATU    = :NRORGULTATU,
                          DTULTATU       = SYSDATE
                    WHERE NRPARCNEGOCIO  = :NRPARCNEGOCIO
                      AND NRORG          = :NRORG
                      AND CDTIPOPARCEIRO = :CDTIPOPARCEIRO";
        try {
            
            $std = $this->connection->prepare($update);
            $std->execute($params);
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function existeRelacParc($params){
        $select = "SELECT COUNT(*) AS COUNT
                     FROM RELACIONAPARC
                    WHERE NRPARCNEGRELAC  = :NRPARCNEGOCIO
                      AND NRORG           = :NRORG
                      AND NRTIPORELACIONA = :NRTIPORELACIONA
                      AND NRPARCNEGOCIO  IN (SELECT NRPARCNEGOCIO
                                               FROM CLIENTE
                                              WHERE CDCLIENTE = :CDCLIENTE
                                                AND NRORG     = :NRORG)";
        try {
            
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
            return $result[0]["COUNT"];
        
        }
        catch(\Exception $e)
        {
            throw new \Exception($e->getMessage());
        };
    } 
    
    public function ativaRelacParc($params) {
        $update = "UPDATE RELACIONAPARC
                      SET IDATIVO         = :IDATIVO,
                          CDOPERULTATU    = :CDOPERULTATU,
                          NRORGULTATU     = :NRORGULTATU,
                          DTULTATU        = SYSDATE
                    WHERE NRPARCNEGRELAC  = :NRPARCNEGOCIO
                      AND NRORG           = :NRORG
                      AND NRTIPORELACIONA = :NRTIPORELACIONA
                      AND NRPARCNEGOCIO  IN (SELECT NRPARCNEGOCIO
                                               FROM CLIENTE
                                              WHERE CDCLIENTE = :CDCLIENTE
                                                AND NRORG     = :NRORG)";
        try {
           
            $std = $this->connection->prepare($update);
            $std->execute($params);
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function existeInteClie($params) {
        $select = "SELECT COUNT(*) AS COUNT
                     FROM INTECLIE
                    WHERE NRRELACIONAPARC IN
                          (SELECT NRRELACIONAPARC
                             FROM RELACIONAPARC
                            WHERE NRPARCNEGRELAC  = :NRPARCNEGOCIO
                              AND NRORG           = :NRORG
                              AND NRTIPORELACIONA = :NRTIPORELACIONA)
                      AND NRORG           = :NRORG
                      AND CDCLIENTE       = :CDCLIENTE";
        try {
            
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
            return $result[0]["COUNT"];
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
    
    public function ativaInteClie($params) {
        $update = "UPDATE INTECLIE
                      SET IDATIVO         = :IDATIVO,
                          CDOPERULTATU    = :CDOPERULTATU,
                          NRORGULTATU     = :NRORGULTATU,
                          DTULTATU        = SYSDATE
                    WHERE NRRELACIONAPARC IN
                          (SELECT NRRELACIONAPARC
                             FROM RELACIONAPARC
                            WHERE NRPARCNEGRELAC  = :NRPARCNEGOCIO
                              AND NRORG           = :NRORG
                              AND NRTIPORELACIONA = :NRTIPORELACIONA)
                      AND NRORG           = :NRORG
                      AND CDCLIENTE       = :CDCLIENTE";
        try {
            
            $std = $this->connection->prepare($update);
            $std->execute($params);
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }
     
    public function existeParceriaInterlocutor($params) {    
        $select = "SELECT COUNT(*) AS COUNT
                     FROM PARCERIA
                    WHERE NRPARCNEGOCIO  = :NRPARCNEGOCIO
                      AND NRORG          = :NRORG
                      AND CDTIPOPARCEIRO = :CDTIPOPARCEIRO";

        try {
            
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $resultado = $std->fetchAll();
            return $resultado[0]["COUNT"];
            
        }catch(\Exception $e) {
            
            throw new \Exception($e->getMessage());
            
        };
    }

    
}